#!/usr/bin/perl -w

# LSB Test Execution Framework
# Results Page Module (tests_results.pl)
#
# Copyright (C) 2007 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';
use Fcntl ':seek';

autoflush_on();

if ($_POST{"remove"}) {
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			next if ($_ eq "");
			my $path = $CONFIG{"RESULTS_DIR"}."/$_";
			if (-d $path) {
				if ($_POST{$_} and ($_POST{$_} eq "on")) {
					system("rm -rf $path");
				}
				else {
					push @list, $_;
				}	
			}
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
	}
	else {
		print STDERR "Cannot open HISTORY file!\n";
	}
	print "HTTP/1.0 302 Moved\nLocation: tests_results.pl\n\n";
	exit;
}

if ($_GET{"generate"}) {
	my $cert = 0;
	if (open(INFO, $SERVER_PARAM{"APP_DATA"}."/results/".$_GET{"generate"}."/INFO")) {
		while (<INFO>) {
			if (m/^Certification$/) {
				$cert = 1;
				last;
			}
		}
		close(INFO);
	}
	system ($CONFIG{"TESTS_DIR"}."/report.pl ".$SERVER_PARAM{"APP_DATA"}."/results/".$_GET{"generate"}." -o lsb-autotest-".$_GET{"generate"}.".tgz".($cert ? " --cert" : "")." >/dev/null 2>&1");
	print "HTTP/1.0 302 Moved\nLocation: tests_results.pl?details=".$_GET{"generate"}."&summary=1\n\n";
	exit;
}

sub print_integration_stuff {
    my $file_location = shift;
    my $certification = shift;

    return if ( $file_location =~ m/^\s*$/ );
    
    my $cert_system_base_addr = "http://$cert_sys_host$cert_sys_base";
    my $cert_system_welcome_addr = $cert_system_base_addr.'welcome_cert.php';

    print '<form action="cert_integration.pl?start" method="post" name="integr_data" style="display:none">';
    print '<input type="hidden" name="file" value="'.$file_location.'">';
    print '<input type="hidden" name="cert" value="1">' if ( $certification );
    print '</form>';
    
    my $link_title = 'Upload the test results';
    if ( $certification ) {
        print "<p>You can easily apply for certification"
            ." by uploading the test results to the "
            ."<a href=\"$cert_system_welcome_addr\">Certification System</a>"
            ." for audit. Just click the button below and follow the instructions."
            ."</p>"
            ; 
        
        $link_title = 'Apply for certification';
    } else {
        print "<p>You can easily upload these test results to the "
            ."<a href=\"$cert_system_welcome_addr\">Certification System</a>."
            ."</p>"
            ;
    }
    
    print '<p>[<a href="#" onclick="document.integr_data.submit(); return false">'
            .$link_title.'</a>]</p>';
}

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

if ($_GET{"details"}) {
	my $name = "test_log.html";
	my $header = "";
	if ($_GET{"summary"} and -f $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"}."/sum_rep.html") {
		$name = "sum_rep.html";
		$header = "sumreport";
	}
	else {
		$header = "detreport";
	}
	print_header("Test Results", $header);
	if (open(FILE, $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"}."/".$name)) {
		my $transfer = 0;
		while (<FILE>) {
			if (m/<body>/) {
				s/^.*<body>\n?//i;
				$transfer = 1;
			}
			if ($transfer) {
				s/(<\/body>|<\/html>)\n?//i;
				
				if ( s/<span id="cert-integration"[^>]*>([^<]*)<\/span>//i ) {
				    my $text = $1;
				    
				    my $filename;
				    my $certification;
				    
				    if ( $text =~ m/\bFILE=([^;]+)/ ) {
				        $filename = $1;
                    }
                    if ( $text =~ m/\bCERTIFICATION=([^;]+)/ ) {
				        $certification = $1;
                    }
				    print_integration_stuff($filename, $certification);
                }
				
				print $_;
			}
		}
		close(FILE);
	}
	else {
		print "<b><font color=\"red\">Sorry, the report '".$_GET{"details"}."' cannot be opened!</font><br />\nReason: $!</b>\n";
	}
}
else {
	print_header("Test Results", "results");

	print "<h1>Test Results</h1>\n";

	print "<form method=\"post\" action=\"tests_results.pl\" name=\"results_list\">\n<table class=\"main\">\n";
	print "  <tr>\n    <td><input type='checkbox' name='check_all' id='check_all' onclick='javascript:check_unckeck_all();' /></td>\n";
	print "    <th width=\"170px\">Date/Time</th>\n";
	print "    <th width=\"170px\">Summary</th>\n";
	print "    <th width=\"300px\">Comment</th>\n  </tr>\n";
	my @list = ();
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			next if ($_ eq "");
			push @list, $_ if (-d $CONFIG{"RESULTS_DIR"}."/$_");
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
		@list = reverse(@list);
		foreach my $name (@list) {
			$_ = $CONFIG{"RESULTS_DIR"}."/$name";
			my @summary = ();
			my @comment = ();
			my $current_field = \@summary;
			if (open(FILE, "$_/INFO")) {
				while (<FILE>) {
					s/&/&amp;/g;
					s/</&lt;/g;
					s/>/&gt;/g;
					s/[\r\n]//g;
					if (($_ eq "") and ($current_field != \@comment)) {
						$current_field = \@comment;
						next;
					}
					push @$current_field, $_;
				}
				close(FILE);
			}
			my $fail = -1;
			my $inprogress = 0;
			my $certification = 0;
			my @extraction = ();
			foreach (@summary) {
				if (m/^Verdict: (\S+)/i) {
					if ($1 eq "Success") {
						$fail = 0;
					}
					elsif ($1 eq "Failed") {
						$fail = 1;
					}
				}
				elsif (m/^In Progress/i) {
					$inprogress = 1;
				}
				elsif (m/^No automatic/i) {
					# Do nothing
				}
				elsif (m/^Certification/i) {
					$certification = 1;
				}
				else {
					# Align numbers by right side (6 digits max)
					s/^(\d+) /("&nbsp;"x(6-length($1))).$1." "/e;
					push @extraction, $_;
				}
			}
			my $jsummary = join("<br />", @extraction);
			$jsummary = "&nbsp;" if ($jsummary eq "");
			my $jcomment = join("<br />", @comment);
			if ($jcomment ne "") {
				$jcomment =~ s/&gt;/>/g;
				$jcomment =~ s/&lt;/</g;
				$jcomment =~ s/&amp;/&/g;
			}
			else {
				$jcomment = "&nbsp;";
			}
			my $image = "";
			my $img_alt = "";
			my $manual_tests = "";
			my $img_float = "";
			if ($fail == -1) {
				$fail = ($jsummary =~ m/(\d+) Tests Failed/) ? $1 : -1;
			}
			$img_alt .= ($certification ? "Cert" : "Tests");
			$img_alt .= (($fail == 1) ? "Failed" : "Passed");
			$img_alt .= ($inprogress ? "Gray" : "");
			$image = "$img_alt.png";
			if ($inprogress) {
				$manual_tests = "<a href=\"tests_appbat.pl?test_run=$name\" title=\"Run manual tests\"><img src=\"images/run_manual.png\" alt=\"\" width=\"16\" height=\"16\" /></a>&nbsp;";
			}
			my $show_name = $name;
			$show_name =~ s/^[^\-]*\-[^\-]*\-([^\-]*)\-([^\-]*)\-([^\-]*)\-([^\-]*)h\-([^\-]*)m\-([^\-]*)s/$3.$2.$1&nbsp;$4:$5:$6/;
			print <<DATA;
  <tr>
    <td rowspan="3"><input type='checkbox' name='$name' onclick='javascript:update_state();' /></td>
    <td rowspan="1" style="border-bottom: none;"><img src="images/environment-spacer.gif" width="1" height="16" alt="" /></td>
    <td rowspan="3" valign="top"><code>$jsummary</code></td>
    <td rowspan="3" valign="top">$jcomment</td>
  </tr>
  <tr>
    <td valign="middle" style="border: none;">
      <img src="images/$image" alt="$img_alt" width="33" height="30" />&nbsp;<a href="tests_results.pl?details=$name&amp;summary=1">$show_name</a>
    </td>
  </tr>
  <tr>
    <td style="border: none; text-align: right; vertical-align: bottom;" width="5" height="5">
      $manual_tests<a href="tests_results.pl?details=$name" title="Show detailed report"><img src="images/report_details.gif" alt="" width="16" height="16" /></a>&nbsp;<a href="tests_results.pl?details=$name&amp;summary=1" title="Show summary report"><img src="images/report_summary.gif" alt="" width="16" height="16" /></a>
    </td>
  </tr>
DATA
		}
	}
	print <<DATA;
</table>
<br /><input type="submit" name="remove" id="remove_button" value="Remove Selected Entries" disabled="disabled" onclick='javascript:return confirm_remove();' />
</form>

<script language="javascript" type="text/javascript">
// <![CDATA[
function count_checked() {
	var num = 0;
	var form = document.results_list;
	for (var i=0; i<form.length; ++i) {
		if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all") && form[i].checked) {
			++num;
		}
	}
	return num;
}

function update_state() {
	var elem = document.getElementById("remove_button");
	if (elem) {
		var num = count_checked();
		elem.disabled = (num == 0);
	}
}

function check_unckeck(box, check) {
	temp = box.onchange;
	box.onchange = null;
	box.checked = check;
	box.onchange = temp;
}

function check_unckeck_all() {
	var elem = document.getElementById("check_all");
	if (elem) {
		var checked = elem.checked;
		var form = document.results_list;
		for (var i=0; i<form.length; ++i) {
			if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all"))
				check_unckeck(form[i], checked);
		}
		update_state();
	}
}

function confirm_remove() {
	var num = count_checked();
	if (num == 0) {
		alert("Nothing selected!");
		return false
	}
	else
		return confirm("Do you wish to delete " + num + " selected report(s)?");
}
// ]]>
</script>
DATA
}

print_footer();
 
